;escapanic room / hectiiiic
;sensenstahl
;www.sensenstahl.com
;fasm 1.69.31
;listening: east of eden - evolve
;____________________________________________________________________________

;controls: w/a/s/d/esc

;the goal is simple and straight forward: move your yellow block
;from the upper left corner to the lower right to get 50.000 points. then the
;level restarts but you need to go back to the upper left. this switching of
;the goal ensures that one needs to hack away in all directions.

;note: to ensure the goal(s) don't get blocked right away the area is kept
;free of spawning blocks.

;during all of that randomly distributed blocks will appear
;which you can't pass. and yes, they pop up every frame.
;so you better hurry and adapt to the evolving maze.
;if you get stuck there is only one real ESCape for you. and if you decide
;to do nothing or you are one of the slow ones it will be reset time for your
;machine. who knows if this is an escape room or a panic room ;)

;the 1st version was 40x25. but that did not work after testing it under
;freedos because it took too long for the mode to set - which i should have
;known because it is not a new issue. anyway, i decided to change the code
;so it runs in 80x25. i then invested a few bytes into centering the play area.
;i could have gone for a bigger field but that was not fun to play during testing
;so i went for the original size of the 40x25 version (which had the adrenaline
;pumping and nerve wrecking blast processing pace only ms-does)

;i added the walls just to make it not too easy. however this is not more than
;a game you might try 1 time (or never) so yeah. it is what it is. sure you can
;SD your way down there but then the random part comes into play so it does not
;work out every time. getting the exit blocked is part of the game.

;but do not worry, your fingers will get tired. this is not your fps where you
;can wait in a nice cosy corner and relax your weak typing bones.

;assuming ax = 0 cx = 255 bx = 0
          standard textmode 80 x 25 set

;global use: si = pos of player
;            bp = rnd seed (not really tho)

;tested on xp, dosbox and freedos

org 100h
use16

scorepos equ 160*24+56+12

start:   push 0b800h ;textmooooooode
         pop ds

         mov ax,1003h; disable blink and enable full 16 bg colors
         int 10h

         mov fs,bx       ;timer

mov si,160+40 ;initial starting point for player

;re-use again of the score routine
;draw initial score on screen
mov bl,18
scrz:
mov byte[ds:scorepos+bx+1],0f9h ;'0' = 48 = 30h / 16*7+1 = 113 = 71h
;dec bx
dec bx
jnz scrz

mov cl,1   ;score + 1 so it is shown from the beginning
jmp addor  ;jump to the score routine + create a new block


next_level:
;mov cx,50000 ;add cx points to the score into screen buffer
mov ch,0fah;64000 and -1b
addor:
mov di,scorepos ;save 2b in total below
mov al,1 ;indicate that score +1 has to be proceeded

;bx = ? after finishing the 1st level
mov bx,9*2; score numbers/digits * 2

scorehandler:
mov dl,byte[ds:di+bx] ;only grab ascii from screen buffer
cmp al,1                    ;next row is coming so +1, set above
jne fine3
inc dl ;score +1
cmp dl,"9"
jna fine4  ;no reminder
mov dl,"0" ;reminder
jmp fine3  ;update score
fine4:
mov al,bh   ;no more change
fine3:

mov byte[ds:di+bx],dl ;set new ascii to the screen

dec bx           ;next digit
dec bx           ;next digit
jnz scorehandler
loop addor       ;add up all score

;setup screen
mov dx,0f000h ;save some bytes

;needed because if you die memory would be identical after restart
;mov di,scorepos+2 ;left of score
inc di
inc di
cls:
mov word[ds:di],dx;0f000h ;flood the segment with white blocks
dec di                    ;only leave out the score area
dec di
cmp di,scorepos+18 ;right of score
jne cls
;jnz cls

mov di,23*160 ;free the playing field
border2:
mov bl,76
border1:
mov word[ds:di+bx+40],cx;0000h
dec bx
dec bx
jnz border1
sub di,160
jnz border2

;mov bx,160+40    ;original player pos
mov bl,200
cmp si,bx        ;is player currently at the goal position?
jne no_switch    ;no
mov bx,160*23+118;yes, so set the goal to the other side
                 ;so the player must use all directions on the keys
no_switch:

mov word[ds:bx],cx;0000h ;set an empty space at the goal pos
                         ;bx is also used below at the check
                         ;if the player reached the goal

;you better hold your horses
mov cl,17
anti_rush_v3:
mov word[ds:di+26+40],dx
mov word[ds:di+160*8+52+40],dx
add di,160
loop anti_rush_v3

mov word[ds:160*7+52+40-2],dx
mov word[ds:160*17+26+40+2],dx

mov word[ds:160*7+52+40-4],dx
mov word[ds:160*17+26+40+4],dx

main:

again2:
in al,40h
sbb ax,dx ;dx = ?
mul al
inc bp ;no 0 all the time
mul bp
xor ax,dx
adc bp,ax
shl bp,1 ;word
cmp bp,160*23+52+40 ;leave space so the goal is not blocked right away :D
jae again2
cmp bp,160+26+40 ;do not block start either
jb again2

cmp word[ds:bp],cx;0 ;is calculated pos empty?
jne again2 ;no so calc a new pos
           ;part of the [no walk in the park] supreme engine
           ;and anti whackster routine
           ;this will create an endless loop when the screen is full
           ;but this only happens if you don't do anything or you don't
           ;hit ESC when you got stuck waiting instead
           ;if this happens to you it is highly likely that you also need
           ;a tutorial on which key to press to jump in a video game ;)
           ;however this can slow down the keypress a bit
           ;but well ... this is on your tired grippers anyway

mov word[ds:bp],0d000h ;set new random block

mov word[ds:si],00efeh ;draw player
                       ;no solid block
                       ;the solid block keeps the being squeezed in
                       ;feeling alive but the smaller square gives
                       ;you visually more room and it looks better

cmp si,bx     ;reached the goal?
je next_level ;yes, so get the score
              ;switch goal to the other side of the room
              ;clean room and start all over

mov ax,word[fs:046ch] ;keep timer intact
again:
cmp word[fs:046ch],ax ;1 frame at a time
je again              ;check again, if time passed

         mov ah,01h
         int 16h
         jz go_on               ;if no key pressed do nothing
                                ;and simply update screen

         mov ah,00h            ;key pressed so get the code
         int 16h               ;nouws

         cmp al,27             ;esc
         je breaker            ;bye bye

;mov dx,160 ;this saves 1b below
            ;at the 2x 160 usage
            ;however i skipped it so dx
            ;keeps being "random" during the
            ;block creation inside the level
            
mov di,si ;copy current position
cut1:    cmp al,97             ;a
         jne cut2
         dec di        ;move
         dec di        ;move
cut2:    cmp al,100            ;d
         jne cut3
         inc di        ;move
         inc di        ;move
cut3:    cmp al,115            ;s
         jne cut4
         add di,160     ;move
cut4:    cmp al,119            ;w
         jne cut5
         sub di,160     ;move
cut5:
cmp word[ds:di],cx;0 ;free space where to move?
jne go_on         ;no
mov word[ds:si],cx;0 ;delete old player
mov si,di         ;set new pos
go_on:

jmp main

breaker: ret ;halt!
         nop ;256